<template>
  <div class="form">
    <div class="fields">
      <email-field />
      <password-field />
      <username-field />
    </div>

    <div class="buttons">
      <div class="button" @click="clearState">
        <button type="reset">clear</button>
      </div>
      <div class="button" @click="signUp">
        <button>Sign-up</button>
      </div>
    </div>
    <nuxt-link :to="{ name: 'sign-in' }">
      Already an user? Sign-in now!</nuxt-link
    >
  </div>
</template>

<script>
import EmailField from '../components/EmailField.vue'
import PasswordField from '../components/PasswordField.vue'
import UsernameField from '../components/UsernameField.vue'

export default {
  components: {
    EmailField,
    PasswordField,
    UsernameField,
  },
  mounted() {
    this.clearState()
  },
  methods: {
    clearState() {
      this.$store.commit('clearEmail')
      this.$store.commit('clearPassword')
      this.$store.commit('clearUsername')
    },
    async signUp() {
      await this.$axios
        .$post('http://localhost:8000/register', {
          email: this.$store.state.email,
          password: this.$store.state.password,
          username: this.$store.state.username,
        })
        .then(
          (response) => {
            this.$axios
              .$get(
                `http://localhost:8000/users?email=${this.$store.state.email}`
              )
              .then((response) => {
                const id = response[0].id
                this.$router.push(`/users/${id}`)
              })
            this.$store.commit('updateToken', response.accessToken)
          },
          () => {
            alert('Email já existe, tente novamento com outro email')
          }
        )
    },
  },
}
</script>

<style>
.form {
  height: 950px;
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
}

.buttons {
  width: 15%;
  display: flex;
  flex-direction: row;
  justify-content: space-between;
}

.button {
  display: flex;
  padding: 20px;
  border: 1px solid black;
  margin-top: 20px;
  margin-bottom: 20px;
}
.fields {
  width: 310px;
  height: 320px;
  display: flex;
  justify-content: space-around;
  flex-direction: column;
}
</style>
